Imports System.Collections

Public Class CharacterData
    Implements IEnumerable

#Region " Private Members "

    Private _Init As Boolean = False
    Private _Entries As Hashtable
    Private Shared _Instance As New CharacterData

    Private Sub New()
    End Sub

#End Region

#Region " Simpleton Interface Exposer "

    Shared ReadOnly Property I() As CharacterData
        Get
            Return _Instance
        End Get
    End Property

#End Region

#Region " Public Members "

    Public Sub Load(ByVal ResName As String)
        _Entries = New Hashtable

        Dim Reader As New IO.StreamReader( _
            Reflection.[Assembly].GetExecutingAssembly().GetManifestResourceStream( _
                Me.[GetType], ResName _
            ) _
        )

        Dim StreamLength As Long = Reader.BaseStream.Length
        Dim Line As String
        Dim ReadOut As Boolean = True

        Do Until Reader.BaseStream.Position = StreamLength
            Line = Reader.ReadLine()

            _Entries.Add(AscW(Line.Chars(0)), Line.Substring(1))
        Loop

        Reader.Close()
        _Init = True
    End Sub

    Public ReadOnly Property Init() As Boolean
        Get
            Return _Init
        End Get
    End Property

    Public ReadOnly Property ReadInfo(ByVal Character As Integer) As String
        Get
            If _Entries.ContainsKey(Character) Then
                Return CStr(_Entries.Item(Character)).ToLower()
            Else
                Return ""
            End If
        End Get
    End Property

    Public Function GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
        Return _Entries.GetEnumerator()
    End Function

#End Region

End Class
